Strict
Framework brl.basic
Import brl.max2d
Import brl.d3d9max2d
Import brl.ramstream
Import brl.jpgloader
Import brl.socket
Import brl.threads
Import brl.timer
Import brl.retro 

Const GW=800,GH=240,HTR$ = "GET /newsticker/ HTTP/1.0~nHost: www.welt.de~n~n",BUFSIZE=1000000
Global update_t, update_thread:TThread, lastupdate$
Global buf:Byte Ptr = MemAlloc(BUFSIZE),gfx

Local timer:TTimer = CreateTimer(60)

If AppArgs.length>=2 And AppArgs[1]="imgs" Then gfx=1

AppTitle = "WELT-NATIVE-NEWSTICKER"
Graphics GW,GH
SetBlend ALPHABLEND
SetClsColor 255,255,255

Tick.dlist = loadnews()
If Not Tick.dlist Then End
update_thread = CreateThread(update, Null)
update_t = MilliSecs()+600000

Repeat
	Cls
	
	Tick.draw
	
	Flip 0
	WaitTimer timer
Until AppTerminate()

End

Function update:Object(unused:Object)
	Local t:Tick, t2:Tick, x, list:Tick[], dlist:Tick[]
	Local z:String, s:TSocket, b:Byte Ptr, n
	list = loadnews()
	If Not list Then Return Null
	dlist = Tick.dlist[..]
	
	For t = EachIn list
		x=1
		For t2 = EachIn dlist
			If t2.news = t.news Then t2.timestamp = MilliSecs(); x = 0; Exit
		Next
	Next
	
	x=0
	While x < dlist.length
		t = dlist[x]
		If t.timestamp < MilliSecs()-30*60000 Then
			dlist = dlist[..x-1]+dlist[x+1..]
		EndIf
		x:+1
	Wend
	
	For t = EachIn dlist
		If gfx And Not t.img Then
			z = "GET "+t.imglink+" HTTP/1.0~nHost: img.welt.de~nConnection: close~n~n~n"
			s = CreateTCPSocket()
			BindSocket s, 0
			While ConnectSocket(s, HostIp("www.welt.de"), 80) = 0;Delay 50;Wend
							
			b = z.toCString()
			s.send b, z.length
			
			While s.readavail()=0;Delay 20;Wend
			n=0
			While s.readavail()
				n :+ s.recv(buf+n, s.readavail())
				Delay 50
			Wend
			CloseSocket s
			b = buf
			search b,"~n~n~n"
	
			b[0]=$FF;b[1]=$D8
			
			t.img = LoadImage(LoadPixmapJPeg(TRamStream.Create(b,n-(b-buf),1,0)))
		EndIf
	Next

	lastupdate = "Letztes Update um "+CurrentTime()
	
	Return dlist
EndFunction

Function search(b:Byte Ptr Var, s$)
	Local l
	While b[0]
		If b[0] = s[l] Then l:+1 Else l=0
		b:+1
		If l = s.length Then Return True
	Wend
	Return False
EndFunction

Function char:String(x)
	If x>=32 And x<=126 Then Return Chr(x) Else Return ""
EndFunction

Function unicode:String(x)
	Select x
	Case $84 Return "Ae"
	Case $96 Return "Oe"
	Case $9C Return "Ue"
	Case $9F Return "ss"
	Case $A4 Return "ae"
	Case $B6 Return "oe"
	Case $BC Return "ue"
	EndSelect
	Return ""
EndFunction

Function loadnews:Tick[]()
	Local s:TSocket = CreateTCPSocket()
	Local n,b:Byte Ptr,t:Tick,z$,list:Tick[]
		
	BindSocket s, 0
	If ConnectSocket(s, HostIp("www.welt.de"), 80) Then	
		s.send HTR.toCString(), HTR.length
		While Not s.readavail(); Delay 20; Wend
		
		b = buf
		Repeat
			n = s.readavail()
			s.recv b, n
			b :+ n
			b[0] = 0
			Delay 150
		Until s.readavail() = 0
		CloseSocket s

		b = buf
		search b, "widget multimedia pagedList    grid_8"
		While search(b,"<div class=~qtsrImg~q>")
			t = New Tick
			
			search b,"<img src=~qhttp://img.welt.de"
			While b[0] And b[0]<>34
				t.imglink :+ Chr(b[0])
				b:+1
			Wend
			
			search b,"<h4 class=~qheadline~q>"
			search b,"href=~q"
			While b[0] And b[0]<>34
				t.link:+char(b[0])
				b:+1
			Wend
			While b[0] And b[0]<>Asc">";b:+1;Wend
			b:+1
			t.news = "+++ "
			While b[0] And b[0]<>Asc"<"
				If b[0] = %11000011 Then
					t.news:+unicode(b[1]).toUpper()
					b:+1
				Else
					t.news:+char(b[0]).toUpper()
				EndIf
				b:+1
			Wend
			t.news :+ " +++"
			t.update
			
			z=""
			search b,"<p>"
			While b[0] And b[0]<> Asc"<"
				If b[0] = %11000011 Then
					z:+unicode(b[1])
					b:+1
				Else
					z:+char(b[0])
				EndIf
				b:+1
			Wend
			z=z.Trim()
			If z Then t.ext=z
			
			If t.news.Replace("+","").Trim() Then list :+ [t]
					
		Wend
		
		
	EndIf
	
	Return list
EndFunction

Function multiline(s$, x, y)
	Local b
	While s
		b = s.find(" ", 50)
		If b < 0 Then
			DrawText s, x, y
			Exit
		Else
			DrawText s[..b], x, y
			y:+16
			s = s[b+1..]
		EndIf
	Wend
EndFunction

Type Tick
	Global clock=-GW, sel:Tick
	Global dlist:Tick[]
	Field news$, w, timestamp, ext$, link$, imglink$, img:TImage
	
	Method New()
		timestamp = MilliSecs()
	EndMethod
	
	Method update()
		w = TextWidth(news)*2
	EndMethod
	
	Method f(i)
		If sel = Self Then 
			SetScale 1,1
			If img Then 
				SetColor 0,0,0
				DrawRect 3,50,ImageWidth(img)+4,ImageHeight(img)+4
				SetColor 255,255,255
				DrawImage img,5,52
			EndIf
			SetColor 100,100,255
			DrawText link,0,GH-36
			DrawRect 0,GH-20,TextWidth(link),2
			SetColor 0,0,0
			If ext Then multiline ext,220,52
			If MouseHit(1) Then OpenURL link
			SetScale 2,2
			If i&1 Then SetColor 255,50,50 Else SetColor 50,50,255
		Else
			If i&1 Then SetColor 200,50,50 Else SetColor 50,50,200
		EndIf		
	EndMethod
	
	Function draw()
		Local w, t:Tick, t2:Tick, i
		SetScale 2,2
		
		If update_thread And ThreadRunning(update_thread)=0 Then
			dlist = Tick[](WaitThread(update_thread))
			update_t = MilliSecs()+600000
			update_thread = Null
		EndIf
		
		For t = EachIn dlist
			i:+1
			
			If w-clock > GW Then Exit
			
			If MouseY()>5 And MouseY()<50 And MouseX()>=w-clock And MouseX() <= w-clock+t.w Then sel = t
			
			t.f i
			
			If w-clock+t.w > 0 Then DrawText t.news, w-clock, 10
			
			w :+ t.w+2
			
			
			If t = dlist[dlist.length-1] And w-clock <= GW Then
				If w-clock <= 0 Then clock = 0;w = 0
				For t2 = EachIn dlist
					i:+1
					If w-clock > GW Then Exit
					t2.f i
					If w-clock+t2.w > 0 Then DrawText t2.news,w-clock,10
					w :+ t2.w+10
				Next
			EndIf
						
		Next
		SetScale 1,1
		
		SetColor 120,120,120
		DrawText lastupdate,0,GH-18
		
		If update_thread=Null And update_t <= MilliSecs() Then update_thread = CreateThread(update, Null)
		
		If dlist Then clock:+2
	EndFunction
EndType
